Package org.apache.lucene.queries.function.valuesource

# Class ComparisonBoolFunction

java.lang.Object
org.apache.lucene.queries.function.ValueSource
org.apache.lucene.queries.function.valuesource.BoolFunction
org.apache.lucene.queries.function.valuesource.ComparisonBoolFunction

public abstract class ComparisonBoolFunction extends BoolFunction
Base class for comparison operators useful within an "if"/conditional.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ComparisonBoolFunction(ValueSource lhs, ValueSource rhs, String name)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract boolean`
  `compare(int doc, FunctionValues lhs, FunctionValues rhs)`
  Perform the comparison, returning true or false
  `void`
  `createWeight(Map<Object,Object> context, IndexSearcher searcher)`
  Implementations should propagate createWeight to sub-ValueSources which can optionally store weight info in the context.
  `String`
  `description()`
  description of field, used in explain()
  `boolean`
  `equals(Object o)`
  `FunctionValues`
  `getValues(Map<Object,Object> context, LeafReaderContext readerContext)`
  Gets the values for this reader and the context that was previously passed to createWeight().
  `int`
  `hashCode()`
  `String`
  `name()`
  Uniquely identify the operation (ie "gt", "lt" "gte", etc)

  ### Methods inherited from class org.apache.lucene.queries.function.ValueSource

  `asDoubleValuesSource, asLongValuesSource, fromDoubleValuesSource, getSortField, newContext, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ComparisonBoolFunction

    public ComparisonBoolFunction(ValueSource lhs, ValueSource rhs, String name)

- ## Method Details

  - ### compare

    public abstract boolean compare(int doc, FunctionValues lhs, FunctionValues rhs) throws IOException
    Perform the comparison, returning true or false
    Throws:
      `IOException`

  - ### name

    public String name()
    Uniquely identify the operation (ie "gt", "lt" "gte", etc)

  - ### getValues

    public FunctionValues getValues(Map<Object,Object> context, LeafReaderContext readerContext) throws IOException
    Description copied from class: `ValueSource`
    Gets the values for this reader and the context that was previously passed to createWeight(). The values must be consumed in a forward docID manner, and you must call this method again to iterate through the values again.
    Specified by:
      `getValues` in class `ValueSource`
    Throws:
      `IOException`

  - ### equals

    public boolean equals(Object o)
    Specified by:
      `equals` in class `ValueSource`

  - ### hashCode

    public int hashCode()
    Specified by:
      `hashCode` in class `ValueSource`

  - ### description

    public String description()
    Description copied from class: `ValueSource`
    description of field, used in explain()
    Specified by:
      `description` in class `ValueSource`

  - ### createWeight

    public void createWeight(Map<Object,Object> context, IndexSearcher searcher) throws IOException
    Description copied from class: `ValueSource`
    Implementations should propagate createWeight to sub-ValueSources which can optionally store weight info in the context. The context object will be passed to getValues() where this info can be retrieved.
    Overrides:
      `createWeight` in class `ValueSource`
    Throws:
      `IOException`